/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is Mouse Gesture for Mozilla.
 *
 * The Initial Developer of the Original Code is Pavol Vaskovic.
 * Portions created by the Initial Developer are Copyright (C) 2001
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *  Andy Edmonds <aedmonds@mindspring.com> 
 *  Ben Williams <benw@webmedia.com.au>
 *  Jeremy Wrinkle (Exotrip)        FIXME  email
 *  Pavol Vaskovic <pali@pali.sk>
 *  Scurrie                         FIXME whole name, email
 *  Steve Kangas <bookmarklets.com> FIXME  email
 *  Squarefree.com                  FIXME who exactly: whole name, email
 *  David Illsley <illsleydc@bigfoot.com>
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

// preferences root branch
var prefRoot = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("");

// *** navigational gestures (& related) ***
addGesture("L","Previous document in history (BACK)","BrowserBack();");
addGesture("R","Next document in history (FORWARD)","BrowserForward();");
addGesture("UD","Reload document","BrowserReload();");
addGesture("UDU","Force Reload Document","BrowserReloadSkipCache();");
addGesture("DURD","Load Home Page","BrowserHome();");
addGesture("RDU", "Scroll Down","window._content.scrollBy(0,200);");
addGesture("RU", "Scroll Up","window._content.scrollBy(0,-200);");
addGesture("D", "Open new document","openNewDocument();");
addGesture("DU","Duplicate Window","window.open(window._content.document.location,'newWin');");
addGesture("ULU","Up a directory in URLspace","upDir();");
// *** tab gestures ***
addGesture("DULR","New Browser Tab","BrowserOpenTab();"); //Contributed by Exotrip
addGesture("DUD","Duplicate Tab","delayedOpenTab(window._content.document.location);");
addGesture("DUR","Next Tab","nextTab();");
addGesture("DUL","Previous Tab","previousTab();");
// *** window manipulation (minimize etc.) ***
// *** Note: works since 012902 
addGesture("UR","Restore or Maximise window","restMaxWin();");
addGesture("DL","Minimize Window","minWin();");
addGesture("RLR", "Close Document [1]","closeDoc();");
addGesture("DR","Close Document [2]","closeDoc();");
// *** misc *** 
addGesture("URD","View Source","viewFrameSource();");
addGesture("LDRDL","View Source","viewFrameSource();"); //Squarish "S"
addGesture("LDR","View Cookies","viewCookies();");
addGesture("URDURD", "Show Meta Info", "metaInfo();");
addGesture("RLDUR","Exploding Background","explodeBackground();");
addGesture("DRDLU","Add Bookmark", "addBookmark();");
// *** link drag over gestures ***
addGesture("UL","Double stack first link in gesture in new window","doubleStackWin();");
addGesture("U","Load Link in New Tab","if(globalOnLink) linkInTab();");
// Diagonals stuff
addGesture("3","Double Image Size","doubleImageSize();");
addGesture("7","Halve Image Size","halveImageSize();");
addGesture("1","Hide Image","hideImage();");
addGesture("131","That's an S","");
addGesture("39","Validate ","w3cValidate();");
// globalOnLink stuff
addGesture("+RU","Open Links in Windows","linksInWindows();");
addGesture("+RUL","Open Links in Tabs","linksInTabs();");

function doubleImageSize(){
  if(globalOnImage) {
    globalOnImage.width = globalOnImage.width * 2;
    globalOnImage.height = globalOnImage.height * 2;
  }
}

function halveImageSize(){
  if(globalOnImage) {
    globalOnImage.width = globalOnImage.width * .5;
    globalOnImage.height = globalOnImage.height * .5;
  }
}

function hideImage(){
  if(globalOnImage) {
    globalOnImage.width = 0;
    globalOnImage.height = 0;
  }
}

function linkInTab(){
  var browser = getBrowser();
  var tab = browser.addTab(globalOnLink[0]);
  if (!prefRoot.getBoolPref("browser.tabs.loadInBackground"))
    browser.selectedTab = tab;
}

function linksInTabs(){
  var browser = getBrowser();
  for(i = 0; i < globalOnLink.length; i++) {
    tab = browser.addTab(globalOnLink[i]);
  }
}

function linksInWindows(){
  for(i = 0; i < globalOnLink.length; i++) {
    tempW = window.open(globalOnLink[i]);
  }
}

function openNewDocument(){
  var tempW;
    if(globalOnImage) {     // Open image in new window
      tempW = window.open(globalOnImage);
    }  
    else {
      if(!globalOnLink) { // open new browser window  
        var uriToLoad = "";
        if (prefRoot.getIntPref("browser.startup.page") == 1)
          uriToLoad = getHomePage();
          openDialog(getBrowserURL(), "_blank","chrome,all,dialog=no",uriToLoad);
        }
      else { tempW = window.open(globalOnLink[0]);} // open link in new window
    }
}

function upDir(){ //from bookmarklets.com
  var aUrl = window._content.document.location.href;
  if (window._content.document.location.protocol != "about:")
    aUrl = aUrl.substring(0, aUrl.substring(0, aUrl.length-1).lastIndexOf('/')+1);
    window._content.document.location.href = aUrl;
}

function nextTab(){ //Contributed by Scurrie
  var tab, curTab, curTabNum, nextTab, l, i, tempW;
  if (getBrowser().mTabContainer.childNodes.length > 1){
    l = getBrowser().mTabContainer.childNodes.length;
    curTab = getBrowser().selectedTab;
    for (i = 0; i < l; i++){
      tab = getBrowser().mTabContainer.childNodes[i];
      if (tab == curTab) {curTabNum = i;}
    }
    if (curTabNum == getBrowser().mTabContainer.childNodes.length-1){
      nextTab = getBrowser().mTabContainer.childNodes[0];
    }
    else {
      nextTab = getBrowser().mTabContainer.childNodes[curTabNum+1]; 
    }
    getBrowser().selectedTab = nextTab;
  }
}

function previousTab(){ //Contributed by Scurrie
  var tab, curTab, curTabNum, nextTab, l, i, tempW;
  if (getBrowser().mTabContainer.childNodes.length > 1){
    l = getBrowser().mTabContainer.childNodes.length;
    curTab = getBrowser().selectedTab;
    for (i = 0; i < l; i++){
      tab = getBrowser().mTabContainer.childNodes[i];
      if (tab == curTab) {curTabNum = i;}
    }
    if (curTabNum == 0){
      curTabNum = getBrowser().mTabContainer.childNodes.length -1;
      nextTab = getBrowser().mTabContainer.childNodes[curTabNum];
    }
    else {
      nextTab = getBrowser().mTabContainer.childNodes[curTabNum-1];}
      getBrowser().selectedTab = nextTab;
    }
}

function restMaxWin(){
  if(window.maximize != 'undefined') {
   if (window.windowState == STATE_MAXIMIZED)
     window.restore();
   else window.maximize();
  }
}

function minWin(){
  if(window.minimize != 'undefined') {
    window.minimize();
  }
}

function closeDoc(){
  if (getBrowser().mTabContainer.childNodes.length > 1)
    getBrowser().removeCurrentTab();
  else window.setTimeout("window.close()", 10); 
}

function viewCookies(){ //Contributed by Squarefree.com
  if (window._content.document.cookie)
    alert('Cookies stored by this host or domain:\n\n'
      + window._content.document.cookie.replace(/; /g,'\n'));
  else alert("No cookies are set for this host or domain.")
}

function metaInfo(){
  var metas = window._content.document.getElementsByTagName("meta");
  if (metas.length != 0){
    var metastr = "Meta Tags: \n\n";
    for(var ameta = 0; ameta < metas.length; ameta++) {
      var mymeta = metas.item(ameta);
      metastr += "<META ";
      if (mymeta.name) metastr += "name=\"" + mymeta.name + "\" ";
      if (mymeta.httpEquiv) metastr+= "http-equiv=\"" + mymeta.httpEquiv + "\" ";
      if (mymeta.content) metastr += "content=\"" + mymeta.content + "\" ";
      if (mymeta.scheme) metastr += "scheme=\"" + mymeta.scheme + "\" ";
      metastr += '>\n';
    }
    alert(metastr);
  }
  else alert("There is no Meta information on this page.");
}

function addBookmark(){
  openDialog("chrome://communicator/content/bookmarks/addBookmark.xul", "",
             "centerscreen,chrome,dialog=yes,dependent,resizable=yes",
             window._content.document.title,
             window._content.document.location,
             "/", null, "");
}

function explodeBackground(){
  myBod = window._content.document.body;
    myBod.background='http://www.surfmind.com/images/explode.gif';
    myBod.setAttribute("style", "background:url(http://www.surfmind.com/images/explode.gif)");
}

function doubleStackWin(){
  var tempW;
  if(globalOnLink) { 
    window.moveTo(0,0);
    window.resizeTo(screen.availWidth/2, screen.availHeight);
    tempW = window.open(globalOnLink[0]);
    tempW.moveTo(screen.availWidth/2 + 1, 0);
    tempW.resizeTo(screen.availWidth/2,screen.availHeight);
  }
}

function w3cValidate() {
window._content.document.location='http://validator.w3.org/check?uri='+window._content.document.location;
}

function viewFrameSource() {
  window.openDialog("chrome://navigator/content/viewSource.xul",
                    "_blank",
                    "scrollbars,resizable,chrome,dialog=no",
                    globalSrcEvent.target.ownerDocument.location.href,
                    "charset=" + globalSrcEvent.target.ownerDocument.characterSet);
}